{-# LANGUAGE NoImplicitPrelude #-}

module StreamTransformer (SF, arr, first, (>>>), loop, init, runSF) where

newtype SF a b = SF { unSF :: a -> (b, SF a b) }

arr f = SF h
  where h x = (f x, SF h)

first f = SF (h f)
  where h f (x, z) = let (y, f') = unSF f x
                     in ((y, z), SF (h f'))

f >>> g = SF (h f g)
  where h f g x = let (y, f') = unSF f x
                      (z, g') = unSF g y
                  in (z, SF (h f' g'))

loop f = SF (h f)
  where h f x = let ((y, z), f') = unSF f (x, z)
                in (y, SF (h f'))

init i = SF (h i)
  where h i x = (i, SF (h x))

runSF :: SF a b -> [a] -> [b]
runSF f = g f
  where g f (x:xs) = let (y, f') = unSF f x
                     in y : g f' xs
